/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     LOGICAL_OR = 258,
     LOGICAL_AND = 259,
     COMPARISION = 260,
     EQUALITY = 261,
     NEGATE = 262,
     TIMES_DIVIDE = 263,
     BASE = 264,
     BREAK = 265,
     TBREAK = 266,
     CLEAR = 267,
     CONDITION = 268,
     CONTINUE = 269,
     DELETE = 270,
     DISASSEMBLE = 271,
     FINISH = 272,
     IF = 273,
     IGNORE = 274,
     NEXT = 275,
     DEBUGGER_OUT = 276,
     PORT = 277,
     READ = 278,
     SET = 279,
     STEP = 280,
     TIME = 281,
     WRITE = 282,
     PAGE = 283,
     REGISTER = 284,
     NUMBER = 285,
     ERROR = 286
   };
#endif
#define LOGICAL_OR 258
#define LOGICAL_AND 259
#define COMPARISION 260
#define EQUALITY 261
#define NEGATE 262
#define TIMES_DIVIDE 263
#define BASE 264
#define BREAK 265
#define TBREAK 266
#define CLEAR 267
#define CONDITION 268
#define CONTINUE 269
#define DELETE 270
#define DISASSEMBLE 271
#define FINISH 272
#define IF 273
#define IGNORE 274
#define NEXT 275
#define DEBUGGER_OUT 276
#define PORT 277
#define READ 278
#define SET 279
#define STEP 280
#define TIME 281
#define WRITE 282
#define PAGE 283
#define REGISTER 284
#define NUMBER 285
#define ERROR 286




/* Copy the first part of user declarations.  */
#line 27 "commandy.y"


#include <config.h>

#include <stdio.h>		/* Needed by NetBSD yacc */
#include <stdlib.h>
#include <string.h>

#include "debugger.h"
#include "debugger_internals.h"
#include "ui/ui.h"
#include "z80/z80.h"
#include "z80/z80_macros.h"

#define YYDEBUG 1
#define YYERROR_VERBOSE



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 46 "commandy.y"
typedef union YYSTYPE {

  int token;
  int reg;

  libspectrum_dword integer;
  debugger_breakpoint_type bptype;
  debugger_breakpoint_life bplife;
  struct { int value1; libspectrum_word value2; } pair;

  debugger_expression* exp;

} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 171 "commandy.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 183 "commandy.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  36
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   171

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  40
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  13
/* YYNRULES -- Number of rules. */
#define YYNRULES  55
/* YYNRULES -- Number of states. */
#define YYNSTATES  90

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    34,     2,
      38,    39,     2,    35,     2,    36,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    37,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    33,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    32,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    11,    16,    22,    27,
      30,    34,    36,    38,    41,    44,    46,    50,    52,    56,
      60,    64,    66,    68,    70,    71,    73,    75,    77,    81,
      83,    85,    87,    89,    90,    93,    94,    96,    97,    99,
     101,   103,   105,   109,   112,   115,   118,   122,   126,   130,
     134,   138,   142,   146,   150,   154
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      41,     0,    -1,    -1,    42,    -1,     1,    -1,     9,    51,
      -1,    43,    44,    45,    48,    -1,    43,    22,    47,    45,
      48,    -1,    43,    26,    51,    48,    -1,    12,    49,    -1,
      13,    30,    50,    -1,    14,    -1,    15,    -1,    15,    51,
      -1,    16,    51,    -1,    17,    -1,    19,    30,    51,    -1,
      20,    -1,    21,    51,    30,    -1,    24,    30,    51,    -1,
      24,    29,    51,    -1,    25,    -1,    10,    -1,    11,    -1,
      -1,    23,    -1,    27,    -1,    49,    -1,    46,    37,    51,
      -1,    28,    -1,    51,    -1,    23,    -1,    27,    -1,    -1,
      18,    52,    -1,    -1,    51,    -1,    -1,    52,    -1,    52,
      -1,    30,    -1,    29,    -1,    38,    52,    39,    -1,    35,
      52,    -1,    36,    52,    -1,     7,    52,    -1,    52,    35,
      52,    -1,    52,    36,    52,    -1,    52,     8,    52,    -1,
      52,     6,    52,    -1,    52,     5,    52,    -1,    52,    34,
      52,    -1,    52,    33,    52,    -1,    52,    32,    52,    -1,
      52,     4,    52,    -1,    52,     3,    52,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   131,   131,   132,   133,   136,   137,   141,   147,   151,
     152,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   168,   169,   172,   173,   174,   177,   178,   181,
     182,   184,   185,   188,   189,   192,   193,   196,   197,   200,
     203,   206,   209,   210,   211,   215,   219,   223,   227,   231,
     235,   239,   243,   247,   251,   257
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "LOGICAL_OR", "LOGICAL_AND", "COMPARISION", 
  "EQUALITY", "NEGATE", "TIMES_DIVIDE", "BASE", "BREAK", "TBREAK", 
  "CLEAR", "CONDITION", "CONTINUE", "DELETE", "DISASSEMBLE", "FINISH", 
  "IF", "IGNORE", "NEXT", "DEBUGGER_OUT", "PORT", "READ", "SET", "STEP", 
  "TIME", "WRITE", "PAGE", "REGISTER", "NUMBER", "ERROR", "'|'", "'^'", 
  "'&'", "'+'", "'-'", "':'", "'('", "')'", "$accept", "input", "command", 
  "breakpointlife", "breakpointtype", "breakpointpair", "pageornumber", 
  "portbreakpointtype", "optionalcondition", "numberorpc", 
  "expressionornull", "number", "expression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   124,    94,    38,    43,    45,    58,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    40,    41,    41,    41,    42,    42,    42,    42,    42,
      42,    42,    42,    42,    42,    42,    42,    42,    42,    42,
      42,    42,    43,    43,    44,    44,    44,    45,    45,    46,
      46,    47,    47,    48,    48,    49,    49,    50,    50,    51,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     1,     2,     4,     5,     4,     2,
       3,     1,     1,     2,     2,     1,     3,     1,     3,     3,
       3,     1,     1,     1,     0,     1,     1,     1,     3,     1,
       1,     1,     1,     0,     2,     0,     1,     0,     1,     1,
       1,     1,     3,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     4,     0,    22,    23,    35,     0,    11,    12,     0,
      15,     0,    17,     0,     0,    21,     0,     3,    24,     0,
      41,    40,     0,     0,     0,     5,    39,     9,    36,    37,
      13,    14,     0,     0,     0,     0,     1,     0,    25,     0,
      26,    35,    45,    43,    44,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    10,    38,    16,    18,
      20,    19,    31,    32,    35,    33,    29,    33,     0,    27,
      36,    42,    55,    54,    50,    49,    48,    53,    52,    51,
      46,    47,    33,     0,     8,     6,     0,     7,    34,    28
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,    16,    17,    18,    41,    67,    68,    64,    84,    69,
      56,    70,    26
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -64
static const short yypact[] =
{
     146,   -64,    80,   -64,   -64,    80,   -12,   -64,    80,    80,
     -64,   -10,   -64,    80,   -28,   -64,    21,   -64,   -13,    80,
     -64,   -64,    80,    80,    80,   -64,    57,   -64,   -64,    80,
     -64,   -64,    80,    -1,    80,    80,   -64,     4,   -64,    80,
     -64,    50,   -64,   -64,   -64,    20,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,   -64,    57,   -64,   -64,
     -64,   -64,   -64,   -64,    50,    16,   -64,    16,     1,   -64,
      12,   -64,    62,    67,   109,     0,   -64,    99,   106,   114,
      42,    42,    16,    80,   -64,   -64,    80,   -64,    57,   -64
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -64,   -64,   -64,   -64,   -64,    -6,   -64,   -64,   -63,    46,
     -64,    -2,    -7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -31
static const yysigned_char yytable[] =
{
      25,    34,    35,    28,    85,    48,    30,    31,    50,    37,
      38,    33,    42,    39,    40,    43,    44,    45,    29,    87,
      32,    36,    57,    46,    47,    48,    49,    62,    50,    59,
      58,    63,    60,    61,    83,    54,    55,    65,    86,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,   -30,
      50,    27,    51,    52,    53,    54,    55,    19,    82,    71,
      46,    47,    48,    49,     0,    50,    47,    48,    49,     0,
      50,     0,    48,    49,     0,    50,    88,     0,    66,    20,
      21,     0,     0,     0,    89,    22,    23,    19,    24,    51,
      52,    53,    54,    55,    51,    52,    53,    54,    55,    51,
      52,    53,    54,    55,    48,    49,     0,    50,     0,    20,
      21,    48,    49,     0,    50,    22,    23,    50,    24,    48,
      49,     0,    50,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    52,    53,    54,    55,     0,     0,     0,     0,
      53,    54,    55,     0,    54,    55,    -2,     1,     0,    54,
      55,     0,     0,     0,     0,     2,     3,     4,     5,     6,
       7,     8,     9,    10,     0,    11,    12,    13,     0,     0,
      14,    15
};

static const yysigned_char yycheck[] =
{
       2,    29,    30,     5,    67,     5,     8,     9,     8,    22,
      23,    13,    19,    26,    27,    22,    23,    24,    30,    82,
      30,     0,    29,     3,     4,     5,     6,    23,     8,    30,
      32,    27,    34,    35,    18,    35,    36,    39,    37,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    37,
       8,     5,    32,    33,    34,    35,    36,     7,    64,    39,
       3,     4,     5,     6,    -1,     8,     4,     5,     6,    -1,
       8,    -1,     5,     6,    -1,     8,    83,    -1,    28,    29,
      30,    -1,    -1,    -1,    86,    35,    36,     7,    38,    32,
      33,    34,    35,    36,    32,    33,    34,    35,    36,    32,
      33,    34,    35,    36,     5,     6,    -1,     8,    -1,    29,
      30,     5,     6,    -1,     8,    35,    36,     8,    38,     5,
       6,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    35,    36,    -1,    -1,    -1,    -1,
      34,    35,    36,    -1,    35,    36,     0,     1,    -1,    35,
      36,    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    19,    20,    21,    -1,    -1,
      24,    25
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    19,    20,    21,    24,    25,    41,    42,    43,     7,
      29,    30,    35,    36,    38,    51,    52,    49,    51,    30,
      51,    51,    30,    51,    29,    30,     0,    22,    23,    26,
      27,    44,    52,    52,    52,    52,     3,     4,     5,     6,
       8,    32,    33,    34,    35,    36,    50,    52,    51,    30,
      51,    51,    23,    27,    47,    51,    28,    45,    46,    49,
      51,    39,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    45,    18,    48,    48,    37,    48,    52,    51
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 136 "commandy.y"
    { debugger_output_base = yyvsp[0].integer; }
    break;

  case 6:
#line 137 "commandy.y"
    {
             debugger_breakpoint_add_address( yyvsp[-2].bptype, yyvsp[-1].pair.value1, yyvsp[-1].pair.value2, 0, yyvsp[-3].bplife,
					      yyvsp[0].exp );
	   }
    break;

  case 7:
#line 141 "commandy.y"
    {
	     int mask; libspectrum_word port;
	     mask = yyvsp[-1].pair.value1; port = yyvsp[-1].pair.value2;
	     if( mask == -1 ) mask = ( port < 0x100 ? 0x00ff : 0xffff );
	     debugger_breakpoint_add_port( yyvsp[-2].bptype, port, mask, 0, yyvsp[-4].bplife, yyvsp[0].exp );
           }
    break;

  case 8:
#line 147 "commandy.y"
    {
	     debugger_breakpoint_add_time( DEBUGGER_BREAKPOINT_TYPE_TIME,
					   yyvsp[-1].integer, 0, yyvsp[-3].bplife, yyvsp[0].exp );
	   }
    break;

  case 9:
#line 151 "commandy.y"
    { debugger_breakpoint_clear( yyvsp[0].integer ); }
    break;

  case 10:
#line 152 "commandy.y"
    {
	     debugger_breakpoint_set_condition( yyvsp[-1].integer, yyvsp[0].exp );
           }
    break;

  case 11:
#line 155 "commandy.y"
    { debugger_run(); }
    break;

  case 12:
#line 156 "commandy.y"
    { debugger_breakpoint_remove_all(); }
    break;

  case 13:
#line 157 "commandy.y"
    { debugger_breakpoint_remove( yyvsp[0].integer ); }
    break;

  case 14:
#line 158 "commandy.y"
    { ui_debugger_disassemble( yyvsp[0].integer ); }
    break;

  case 15:
#line 159 "commandy.y"
    { debugger_breakpoint_exit(); }
    break;

  case 16:
#line 160 "commandy.y"
    { debugger_breakpoint_ignore( yyvsp[-1].integer, yyvsp[0].integer ); }
    break;

  case 17:
#line 161 "commandy.y"
    { debugger_next(); }
    break;

  case 18:
#line 162 "commandy.y"
    { debugger_port_write( yyvsp[-1].integer, yyvsp[0].integer ); }
    break;

  case 19:
#line 163 "commandy.y"
    { debugger_poke( yyvsp[-1].integer, yyvsp[0].integer ); }
    break;

  case 20:
#line 164 "commandy.y"
    { debugger_register_set( yyvsp[-1].reg, yyvsp[0].integer ); }
    break;

  case 21:
#line 165 "commandy.y"
    { debugger_step(); }
    break;

  case 22:
#line 168 "commandy.y"
    { yyval.bplife = DEBUGGER_BREAKPOINT_LIFE_PERMANENT; }
    break;

  case 23:
#line 169 "commandy.y"
    { yyval.bplife = DEBUGGER_BREAKPOINT_LIFE_ONESHOT; }
    break;

  case 24:
#line 172 "commandy.y"
    { yyval.bptype = DEBUGGER_BREAKPOINT_TYPE_EXECUTE; }
    break;

  case 25:
#line 173 "commandy.y"
    { yyval.bptype = DEBUGGER_BREAKPOINT_TYPE_READ; }
    break;

  case 26:
#line 174 "commandy.y"
    { yyval.bptype = DEBUGGER_BREAKPOINT_TYPE_WRITE; }
    break;

  case 27:
#line 177 "commandy.y"
    { yyval.pair.value1 = -1; yyval.pair.value2 = yyvsp[0].integer; }
    break;

  case 28:
#line 178 "commandy.y"
    { yyval.pair.value1 = yyvsp[-2].integer; yyval.pair.value2 = yyvsp[0].integer; }
    break;

  case 29:
#line 181 "commandy.y"
    { yyval.integer = yyvsp[0].integer; }
    break;

  case 30:
#line 182 "commandy.y"
    { yyval.integer = yyvsp[0].integer; }
    break;

  case 31:
#line 184 "commandy.y"
    { yyval.bptype = DEBUGGER_BREAKPOINT_TYPE_PORT_READ; }
    break;

  case 32:
#line 185 "commandy.y"
    { yyval.bptype = DEBUGGER_BREAKPOINT_TYPE_PORT_WRITE; }
    break;

  case 33:
#line 188 "commandy.y"
    { yyval.exp = NULL; }
    break;

  case 34:
#line 189 "commandy.y"
    { yyval.exp = yyvsp[0].exp; }
    break;

  case 35:
#line 192 "commandy.y"
    { yyval.integer = PC; }
    break;

  case 36:
#line 193 "commandy.y"
    { yyval.integer = yyvsp[0].integer; }
    break;

  case 37:
#line 196 "commandy.y"
    { yyval.exp = NULL; }
    break;

  case 38:
#line 197 "commandy.y"
    { yyval.exp = yyvsp[0].exp; }
    break;

  case 39:
#line 200 "commandy.y"
    { yyval.integer = debugger_expression_evaluate( yyvsp[0].exp ); }
    break;

  case 40:
#line 203 "commandy.y"
    { yyval.exp = debugger_expression_new_number( yyvsp[0].integer );
		       if( !yyval.exp ) YYABORT;
		     }
    break;

  case 41:
#line 206 "commandy.y"
    { yyval.exp = debugger_expression_new_register( yyvsp[0].reg );
			 if( !yyval.exp ) YYABORT;
		       }
    break;

  case 42:
#line 209 "commandy.y"
    { yyval.exp = yyvsp[-1].exp; }
    break;

  case 43:
#line 210 "commandy.y"
    { yyval.exp = yyvsp[0].exp; }
    break;

  case 44:
#line 211 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_unaryop( '-', yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 45:
#line 215 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_unaryop( yyvsp[-1].token, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 46:
#line 219 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( '+', yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 47:
#line 223 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( '-', yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 48:
#line 227 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( yyvsp[-1].token, yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 49:
#line 231 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( yyvsp[-1].token, yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 50:
#line 235 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( yyvsp[-1].token, yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 51:
#line 239 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( '&', yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 52:
#line 243 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( '^', yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 53:
#line 247 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop( '|', yyvsp[-2].exp, yyvsp[0].exp );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 54:
#line 251 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop(
                  DEBUGGER_TOKEN_LOGICAL_AND, yyvsp[-2].exp, yyvsp[0].exp
                );
		if( !yyval.exp ) YYABORT;
	      }
    break;

  case 55:
#line 257 "commandy.y"
    {
	        yyval.exp = debugger_expression_new_binaryop(
		  DEBUGGER_TOKEN_LOGICAL_OR, yyvsp[-2].exp, yyvsp[0].exp
		);
		if( !yyval.exp ) YYABORT;
	      }
    break;


    }

/* Line 999 of yacc.c.  */
#line 1464 "commandy.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 265 "commandy.y"


